﻿using System;
using System.IO;

namespace BeatLyrics.Common
{
    public static class DirProvider
    {
        public const string SuffixSet = ".set.txt";
        public const string SuffixVerify = ".verify.txt";

        public static string BeatSaberDir => Environment.GetEnvironmentVariable("BeatSaberDir");
        public static string BeatLyricsDir => Environment.GetEnvironmentVariable("BeatLyricsDir");

        public static string GetLyricDir(string hash) => Path.Combine(BeatLyricsDir, "custom_level_" + hash);

        public static string GetDefaultFile(string hash) => GetLyricDir(hash) + SuffixSet;
        public static string GetVerifyFile(string hash) => GetLyricDir(hash) + SuffixVerify;
    }
}
