﻿using BeatLyrics.Tool.Models;
using BeatLyrics.Tool.Utils;
using System;
using System.Collections.Generic;

namespace BeatLyrics.Tool.DataProvider.OnlineLyric.Models
{
    public class LyricSearchResultItem
    {
        public LyricSearchResultItem(string providerName)
        {
            ProviderName = providerName;
        }

        public string ProviderName { get; }

        public string Id { get; set; }
        public string Name { get; set; }
        public int Duration { get; set; }

        public string DurationText
        {
            get
            {
                var timeSpan = TimeSpan.FromMilliseconds(Duration);
                return timeSpan.FormatToTotalMinuteAndSeconds();
            }
        }

        public string Remarks { get; set; }
        public string Artists { get; set; }

        public bool IsDetailsLoaded { get; set; }
        public List<LyricDetailExt> Details { get; set; }
        public List<LyricDetailExt> DetailsTranslated { get; set; }

        public string DetailsText { get; set; }
        public string DetailsTranslatedText { get; set; }

        public override string ToString()
        {
            return $"{Name} - {Artists} [{DurationText}] #{Id} {Remarks}";
        }
    }
}
